Index: /LMDZ6/branches/cirrus/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 4951)
@@ -49,5 +49,6 @@
     prw_ancien, u10m,v10m, treedrg, u_ancien, v_ancien, wake_delta_pbl_TKE, wake_dens, &
     ale_bl, ale_bl_trig, alp_bl, &
-    ale_wake, ale_bl_stat, AWAKE_S
+    ale_wake, ale_bl_stat, AWAKE_S, &
+    cf_ancien, rvc_ancien
 
   USE comconst_mod, ONLY: pi, dtvr
@@ -94,5 +95,5 @@
   USE init_ssrf_m, ONLY: start_init_subsurf
   USE phys_state_var_mod, ONLY: beta_aridity, delta_tsurf, awake_dens, cv_gen, &
-       ratqs_inter_, rneb_ancien
+       ratqs_inter_
   !use ioipsl_getincom
   IMPLICIT NONE
@@ -242,4 +243,7 @@
   ale_wake=0.
   ale_bl_stat=0.
+
+  cf_ancien = 0.
+  rvc_ancien = 0.
   
   z0m(:,:)=0 ! ym missing 5th subsurface initialization
@@ -287,5 +291,4 @@
 
   ratqs_inter_ = 0.002
-  rneb_ancien = 0.
   CALL phyredem( "startphy.nc" )
 
Index: /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 4951)
@@ -114,9 +114,9 @@
   !--- SOME PARAMETERS THAT ARE NOT LIKELY TO CHANGE OFTEN
   CHARACTER(LEN=maxlen), SAVE      :: tran0        = 'air'      !--- Default transporting fluid
-  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlirb'     !--- Old phases for water (no separator)
-  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsrb'     !--- Known phases initials
+  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlifbc'     !--- Old phases for water (no separator)
+  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsfbc'     !--- Known phases initials
   INTEGER, PARAMETER :: nphases = LEN_TRIM(known_phases)        !--- Number of phases
   CHARACTER(LEN=maxlen), SAVE      :: phases_names(nphases) &   !--- Known phases names
-                                = ['gaseous', 'liquid ', 'solid  ', 'cloud  ','blosno ']
+                                = ['gaseous', 'liquid ', 'solid  ', 'fracld ', 'blosnow', 'cldvapr']
   CHARACTER(LEN=1), SAVE :: phases_sep  =  '_'                  !--- Phase separator
   LOGICAL,          SAVE :: tracs_merge = .TRUE.                !--- Merge/stack tracers lists
Index: /LMDZ6/branches/cirrus/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/clesphys.h	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/clesphys.h	(revision 4951)
@@ -94,5 +94,5 @@
        LOGICAL :: ok_airs
        INTEGER :: ip_ebil_phy, iflag_rrtm, iflag_ice_thermo, NSW, iflag_albedo
-       LOGICAL :: ok_ice_sursat, ok_plane_h2o, ok_plane_contrail
+       LOGICAL :: ok_ice_supersat, ok_plane_h2o, ok_plane_contrail
        LOGICAL :: ok_chlorophyll
        LOGICAL :: ok_strato
@@ -154,5 +154,5 @@
      &     , ok_lic_melt, ok_lic_cond, aer_type                         &
      &     , iflag_rrtm, ok_strato,ok_hines, ok_qch4                    &
-     &     , iflag_ice_thermo, ok_ice_sursat                            & 
+     &     , iflag_ice_thermo, ok_ice_supersat                          & 
      &     , ok_plane_h2o, ok_plane_contrail                            & 
      &     , ok_gwd_rando, NSW, iflag_albedo                            &
Index: /LMDZ6/branches/cirrus/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/conf_phys_m.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/conf_phys_m.F90	(revision 4951)
@@ -173,5 +173,5 @@
     INTEGER,SAVE :: iflag_clw_omp
     INTEGER,SAVE :: iflag_ice_thermo_omp
-    LOGICAL,SAVE :: ok_ice_sursat_omp
+    LOGICAL,SAVE :: ok_ice_supersat_omp
     LOGICAL,SAVE :: ok_plane_h2o_omp, ok_plane_contrail_omp
     REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
@@ -1347,15 +1347,15 @@
 
     !
-    !Config Key  = ok_ice_sursat
-    !Config Desc =
-    !Config Def  = 0
-    !Config Help =
-    !
-    ok_ice_sursat_omp = 0
-    CALL getin('ok_ice_sursat',ok_ice_sursat_omp)
+    !Config Key  = ok_ice_supersat
+    !Config Desc = include ice supersaturation for cold clouds
+    !Config Def  = .FALSE.
+    !Config Help =
+    !
+    ok_ice_supersat_omp = .FALSE.
+    CALL getin('ok_ice_supersat',ok_ice_supersat_omp)
 
     !Config Key  = ok_plane_h2o
-    !Config Desc =
-    !Config Def  = 0
+    !Config Desc = include H2O emissions from aviation
+    !Config Def  = .FALSE.
     !Config Help =
     !
@@ -1364,6 +1364,6 @@
 
     !Config Key  = ok_plane_contrail
-    !Config Desc =
-    !Config Def  = 0
+    !Config Desc = include the formation of contrail cirrus clouds
+    !Config Def  = .FALSE.
     !Config Help =
     !
@@ -2345,5 +2345,5 @@
     rad_chau2 = rad_chau2_omp
     iflag_ice_thermo = iflag_ice_thermo_omp
-    ok_ice_sursat = ok_ice_sursat_omp
+    ok_ice_supersat = ok_ice_supersat_omp
     ok_plane_h2o = ok_plane_h2o_omp
     ok_plane_contrail = ok_plane_contrail_omp
@@ -2770,5 +2770,5 @@
     WRITE(lunout,*) ' rad_chau2 = ',rad_chau2
     WRITE(lunout,*) ' iflag_ice_thermo = ',iflag_ice_thermo
-    WRITE(lunout,*) ' ok_ice_sursat = ',ok_ice_sursat
+    WRITE(lunout,*) ' ok_ice_supersat = ',ok_ice_supersat
     WRITE(lunout,*) ' ok_plane_h2o = ',ok_plane_h2o
     WRITE(lunout,*) ' ok_plane_contrail = ',ok_plane_contrail
Index: /LMDZ6/branches/cirrus/libf/phylmd/create_etat0_unstruct_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/create_etat0_unstruct_mod.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/create_etat0_unstruct_mod.F90	(revision 4951)
@@ -258,4 +258,8 @@
     prw_ancien = 0.
     agesno = 0.
+    
+    ! LSCP condensation and ice supersaturation
+    cf_ancien = 0.
+    rvc_ancien = 0.
 
     wake_delta_pbl_TKE(:,:,:)=0
@@ -310,5 +314,4 @@
     END IF
     ratqs_inter_ = 0.002
-    rneb_ancien = 0.
 
     CALL gather_omp(cell_area,cell_area_mpi)
Index: /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp.F90	(revision 4951)
@@ -8,5 +8,5 @@
 SUBROUTINE lscp(klon,klev,dtime,missing_val,            &
      paprs,pplay,temp,qt,ptconv,ratqs,                  &
-     d_t, d_q, d_ql, d_qi, rneb, rneblsvol, rneb_seri,  &
+     d_t, d_q, d_ql, d_qi, rneb, rneblsvol,             &
      pfraclr,pfracld,                                   &
      radocond, radicefrac, rain, snow,                  &
@@ -14,8 +14,12 @@
      prfl, psfl, rhcl, qta, fraca,                     &
      tv, pspsk, tla, thl, iflag_cld_th,             &
-     iflag_ice_thermo, ok_ice_sursat, qsatl, qsats,     &
-     distcltop,temp_cltop,                              &
-     qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss,   &
-     Tcontr, qcontr, qcontr2, fcontrN, fcontrP,         &
+     iflag_ice_thermo, distcltop, temp_cltop, cell_area,&
+     cf_seri, rvc_seri, u_seri, v_seri, pbl_eps,        &
+     qsub, qissr, qcld, subfra, issrfra, gamma_cond,    &
+     ratio_qi_qtot, dcf_sub, dcf_con, dcf_mix,          &
+     dqi_adj, dqi_sub, dqi_con, dqi_mix, dqvc_adj,      &
+     dqvc_sub, dqvc_con, dqvc_mix, qsatl, qsati,        &
+     Tcontr, qcontr, qcontr2, fcontrN, fcontrP, dcf_avi,&
+     dqi_avi, dqvc_avi, flight_dist, flight_h2o,        &
      cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv, &
      qraindiag, qsnowdiag, dqreva, dqssub, dqrauto,     &
@@ -98,9 +102,9 @@
 USE lmdz_lscp_tools, ONLY : calc_qsat_ecmwf, icefrac_lscp, calc_gammasat
 USE lmdz_lscp_tools, ONLY : fallice_velocity, distance_to_cloud_top
-USE ice_sursat_mod, ONLY : ice_sursat
+USE lmdz_lscp_condensation, ONLY : condensation_lognormal, condensation_ice_supersat
 USE lmdz_lscp_poprecip, ONLY : poprecip_precld, poprecip_postcld
 
 ! Use du module lmdz_lscp_ini contenant les constantes
-USE lmdz_lscp_ini, ONLY : prt_level, lunout
+USE lmdz_lscp_ini, ONLY : prt_level, lunout, eps
 USE lmdz_lscp_ini, ONLY : seuil_neb, niter_lscp, iflag_evap_prec, t_coup, DDT0, ztfondue, rain_int_min
 USE lmdz_lscp_ini, ONLY : ok_radocond_snow, a_tr_sca, cld_expo_con, cld_expo_lsc
@@ -111,4 +115,5 @@
 USE lmdz_lscp_ini, ONLY : RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RG
 USE lmdz_lscp_ini, ONLY : ok_poprecip
+USE lmdz_lscp_ini, ONLY : ok_external_lognormal, ok_ice_supersat, ok_unadjusted_clouds
 
 IMPLICIT NONE
@@ -132,6 +137,4 @@
   INTEGER,                         INTENT(IN)   :: iflag_ice_thermo! flag to activate the ice thermodynamics
                                                                    ! CR: if iflag_ice_thermo=2, only convection is active
-  LOGICAL,                         INTENT(IN)   :: ok_ice_sursat   ! flag to determine if ice sursaturation is activated
-
   LOGICAL, DIMENSION(klon,klev),   INTENT(IN)   :: ptconv          ! grid points where deep convection scheme is active
 
@@ -150,7 +153,18 @@
   REAL, DIMENSION(klon,klev),      INTENT(INOUT)   :: ratqs        ! function of pressure that sets the large-scale
 
-
-  ! Input sursaturation en glace
-  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: rneb_seri        ! fraction nuageuse en memoire
+  ! INPUT/OUTPUT condensation and ice supersaturation
+  !--------------------------------------------------
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: cf_seri          ! cloud fraction [-]
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: ratio_qi_qtot    ! solid specific water to total specific water ratio [-]
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: rvc_seri         ! cloudy water vapor to total water vapor ratio [-]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: u_seri           ! eastward wind [m/s]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: v_seri           ! northward wind [m/s]
+  REAL, DIMENSION(klon,klev+1),    INTENT(IN)   :: pbl_eps          ! TKE dissipation [?]
+  REAL, DIMENSION(klon),           INTENT(IN)   :: cell_area        ! area of each cell [m2]
+
+  ! INPUT/OUTPUT aviation
+  !--------------------------------------------------
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: flight_dist      ! Aviation distance flown within the mesh [m/s/mesh]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: flight_h2o       ! Aviation H2O emitted within the mesh [kg H2O/s/mesh]
   
   ! OUTPUT variables
@@ -170,6 +184,4 @@
   REAL, DIMENSION(klon),           INTENT(OUT)  :: rain             ! surface large-scale rainfall [kg/s/m2] 
   REAL, DIMENSION(klon),           INTENT(OUT)  :: snow             ! surface large-scale snowfall [kg/s/m2]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsatl            ! saturation specific humidity wrt liquid [kg/kg]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsats            ! saturation specific humidity wrt ice [kg/kg]  
   REAL, DIMENSION(klon,klev+1),    INTENT(OUT)  :: prfl             ! large-scale rainfall flux in the column [kg/s/m2]
   REAL, DIMENSION(klon,klev+1),    INTENT(OUT)  :: psfl             ! large-scale snowfall flux in the column [kg/s/m2]
@@ -183,22 +195,37 @@
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: frac_nucl        ! scavenging fraction due tu nucleation [-]
   
-  ! for supersaturation and contrails parameterisation
-  
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qclr             ! specific total water content in clear sky region [kg/kg]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcld             ! specific total water content in cloudy region [kg/kg]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qss              ! specific total water content in supersat region [kg/kg]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qvc              ! specific vapor content in clouds [kg/kg] 
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rnebclr          ! mesh fraction of clear sky [-]   
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rnebss           ! mesh fraction of ISSR [-]  
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: gamma_ss         ! coefficient governing the ice nucleation RHi threshold [-]      
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: Tcontr           ! threshold temperature for contrail formation [K]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr           ! threshold humidity for contrail formation [kg/kg]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr2          ! // (2nd expression more consistent with LMDZ expression of q)          
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrN          ! fraction of grid favourable to non-persistent contrails
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrP          ! fraction of grid favourable to persistent contrails
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sth      ! mean saturation deficit in thermals
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_senv     ! mean saturation deficit in environment
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sigmath  ! std of saturation deficit in thermals
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sigmaenv ! std of saturation deficit in environment
+  ! for condensation and ice supersaturation
+
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsub           !--specific total water content in sub-saturated clear sky region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qissr          !--specific total water content in supersat region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcld           !--specific total water content in cloudy region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: subfra         !--mesh fraction of subsaturated clear sky [-]   
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: issrfra        !--mesh fraction of ISSR [-]  
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: gamma_cond     !--coefficient governing the ice nucleation RHi threshold [-]      
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dcf_sub        !--cloud fraction tendency because of sublimation [s-1]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dcf_con        !--cloud fraction tendency because of condensation [s-1]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dcf_mix        !--cloud fraction tendency because of cloud mixing [s-1]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqi_adj        !--specific ice content tendency because of temperature adjustment [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqi_sub        !--specific ice content tendency because of sublimation [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqi_con        !--specific ice content tendency because of condensation [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqi_mix        !--specific ice content tendency because of cloud mixing [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqvc_adj       !--specific cloud water vapor tendency because of temperature adjustment [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqvc_sub       !--specific cloud water vapor tendency because of sublimation [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqvc_con       !--specific cloud water vapor tendency because of condensation [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqvc_mix       !--specific cloud water vapor tendency because of cloud mixing [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsatl          !--saturation specific humidity wrt liquid [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsati          !--saturation specific humidity wrt ice [kg/kg]  
+
+  ! for contrails and aviation
+
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: Tcontr         !--threshold temperature for contrail formation [K]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr         !--threshold humidity for contrail formation [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr2        !--// (2nd expression more consistent with LMDZ expression of q)
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrN        !--fraction of grid favourable to non-persistent contrails
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrP        !--fraction of grid favourable to persistent contrails
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dcf_avi        !--cloud fraction tendency because of aviation [s-1]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqi_avi        !--specific ice content tendency because of aviation [kg/kg/s]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqvc_avi       !--specific cloud water vapor tendency because of aviation [kg/kg/s]
+
 
   ! for POPRECIP
@@ -217,4 +244,11 @@
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqsfreez       !--snow tendency due to freezing [kg/kg/s]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: dqrfreez       !--rain tendency due to freezing [kg/kg/s]
+
+  ! for thermals
+
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sth      !--mean saturation deficit in thermals
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_senv     !--mean saturation deficit in environment
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sigmath  !--std of saturation deficit in thermals
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: cloudth_sigmaenv !--std of saturation deficit in environment
 
 
@@ -282,4 +316,15 @@
   REAL :: effective_zneb
   REAL, DIMENSION(klon) :: distcltop1D, temp_cltop1D
+  
+  ! for condensation and ice supersaturation
+  REAL, DIMENSION(klon) :: qvc, shear
+  REAL :: delta_z
+  !--Added for ice supersaturation (ok_ice_supersat) and contrails (ok_plane_contrails)
+  ! Constants used for calculating ratios that are advected (using a parent-child
+  ! formalism). This is not done in the dynamical core because at this moment,
+  ! only isotopes can use this parent-child formalism. Note that the two constants
+  ! are the same as the one use in the dynamical core, being also defined in
+  ! dyn3d_common/infotrac.F90
+  REAL :: min_qParent, min_ratio
 
 
@@ -363,15 +408,36 @@
 temp_cltop1D(:) = 0.0
 ztupnew(:)=0.0
-!--ice supersaturation
-gamma_ss(:,:) = 1.0
-qss(:,:) = 0.0
-rnebss(:,:) = 0.0
-Tcontr(:,:) = missing_val
-qcontr(:,:) = missing_val
-qcontr2(:,:) = missing_val
-fcontrN(:,:) = 0.0
-fcontrP(:,:) = 0.0
+
 distcltop(:,:)=0.
 temp_cltop(:,:)=0.
+
+!--Ice supersaturation
+gamma_cond(:,:) = 1.
+qissr(:,:)      = 0.
+issrfra(:,:)    = 0.
+dcf_sub(:,:)    = 0.
+dcf_con(:,:)    = 0.
+dcf_mix(:,:)    = 0.
+dqi_adj(:,:)    = 0.
+dqi_sub(:,:)    = 0.
+dqi_con(:,:)    = 0.
+dqi_mix(:,:)    = 0.
+dqvc_adj(:,:)   = 0.
+dqvc_sub(:,:)   = 0.
+dqvc_con(:,:)   = 0.
+dqvc_mix(:,:)   = 0.
+fcontrN(:,:)    = 0.
+fcontrP(:,:)    = 0.
+Tcontr(:,:)     = missing_val
+qcontr(:,:)     = missing_val
+qcontr2(:,:)    = missing_val
+dcf_avi(:,:)    = 0.
+dqi_avi(:,:)    = 0.
+dqvc_avi(:,:)   = 0.
+qvc(:)          = 0.
+shear(:)        = 0.
+min_qParent     = 1.e-30
+min_ratio       = 1.e-16
+
 !-- poprecip
 qraindiag(:,:)= 0.
@@ -759,4 +825,6 @@
                     rneblsvol(i,k)=ctot_vol(i,k)
                     zqn(i)=qcloud(i)
+                    !--AB grid-mean vapor in the cloud - we assume saturation adjustment
+                    qvc(i) = rneb(i,k) * zqs(i)
                 ENDDO
 
@@ -794,12 +862,15 @@
         DO iter=1,iflag_fisrtilp_qsat+1
 
+                keepgoing(:) = .FALSE.
+
                 DO i=1,klon
 
                     ! keepgoing = .true. while convergence is not satisfied
-                    keepgoing(i)=ABS(DT(i)).GT.DDT0
-
-                    IF ((keepgoing(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
+
+                    IF (((ABS(DT(i)).GT.DDT0) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
 
                         ! if not convergence:
+                        ! we calculate a new iteration
+                        keepgoing(i) = .TRUE.
 
                         ! P2.2.1> cloud fraction and condensed water mass calculation
@@ -833,7 +904,65 @@
                   CALL icefrac_lscp(klon, zt(:), iflag_ice_thermo, distcltop1D(:),temp_cltop1D(:),zfice(:),dzfice(:))
 
+
+                  !--AB Activates a condensation scheme that allows for
+                  !--ice supersaturation and contrails evolution from aviation
+                  IF (ok_ice_supersat) THEN
+
+                    !--Calculate the shear value (input for condensation and ice supersat)
+                    DO i = 1, klon
+                      !--Cell thickness [m]
+                      delta_z = ( paprs(i,k) - paprs(i,k+1) ) / RG / pplay(i,k) * Tbef(i) * RD
+                      IF ( iftop ) THEN
+                        ! top
+                        shear(i) = SQRT( ( (u_seri(i,k) - u_seri(i,k-1)) / delta_z )**2. &
+                                       + ( (v_seri(i,k) - v_seri(i,k-1)) / delta_z )**2. )
+                      ELSEIF ( k .EQ. 1 ) THEN
+                        ! surface
+                        shear(i) = SQRT( ( (u_seri(i,k+1) - u_seri(i,k)) / delta_z )**2. &
+                                       + ( (v_seri(i,k+1) - v_seri(i,k)) / delta_z )**2. )
+                      ELSE
+                        ! other layers
+                        shear(i) = SQRT( ( ( (u_seri(i,k+1) + u_seri(i,k)) / 2. &
+                                           - (u_seri(i,k) + u_seri(i,k-1)) / 2. ) / delta_z )**2. &
+                                       + ( ( (v_seri(i,k+1) + v_seri(i,k)) / 2. &
+                                           - (v_seri(i,k) + v_seri(i,k-1)) / 2. ) / delta_z )**2. )
+                      ENDIF
+                    ENDDO
+
+                    !---------------------------------------------
+                    !--   CONDENSATION AND ICE SUPERSATURATION  --
+                    !---------------------------------------------
+
+                    CALL condensation_ice_supersat( &
+                        klon, dtime, missing_val, &
+                        pplay(:,k), paprs(:,k), paprs(:,k+1), &
+                        cf_seri(:,k), rvc_seri(:,k), ratio_qi_qtot(:,k), &
+                        shear(:), pbl_eps(:,k), cell_area(:), &
+                        Tbef(:), zq(:), zqs(:), gammasat(:), ratqs(:,k), keepgoing(:), &
+                        rneb(:,k), zqn(:), qvc(:), issrfra(:,k), qissr(:,k), &
+                        dcf_sub(:,k), dcf_con(:,k), dcf_mix(:,k), &
+                        dqi_adj(:,k), dqi_sub(:,k), dqi_con(:,k), dqi_mix(:,k), &
+                        dqvc_adj(:,k), dqvc_sub(:,k), dqvc_con(:,k), dqvc_mix(:,k), &
+                        Tcontr(:,k), qcontr(:,k), qcontr2(:,k), fcontrN(:,k), fcontrP(:,k), &
+                        flight_dist(:,k), flight_h2o(:,k), &
+                        dcf_avi(:,k), dqi_avi(:,k), dqvc_avi(:,k))
+
+
+                  !--If .TRUE., calls an externalised version of the generalised
+                  !--lognormal condensation scheme (Bony and Emanuel 2001)
+                  !--Numerically, convergence is conserved with this option
+                  !--The objective is to simplify LSCP
+                  ELSEIF ( ok_external_lognormal ) THEN
+                          
+                   CALL condensation_lognormal( &
+                       klon, Tbef(:), zq(:), zqs(:), gammasat(:), ratqs(:,k), &
+                       keepgoing(:), rneb(:,k), zqn(:), qvc(:))
+
+
+                 ELSE !--Generalised lognormal (Bony and Emanuel 2001)
+
                   DO i=1,klon !todoan : check if loop in i is needed
 
-                      IF ((keepgoing(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
+                      IF (keepgoing(i)) THEN
 
                         zpdf_sig(i)=ratqs(i,k)*zq(i)
@@ -849,31 +978,23 @@
                         zpdf_e2(i)=1.-erf(zpdf_e2(i))
 
-                        IF ((.NOT.ok_ice_sursat).OR.(Tbef(i).GT.t_glace_min)) THEN
-
                           IF (zpdf_e1(i).LT.1.e-10) THEN
                               rneb(i,k)=0.
-                              zqn(i)=gammasat(i)*zqs(i)
+                              zqn(i)=zqs(i)
+                              !--AB grid-mean vapor in the cloud - we assume saturation adjustment
+                              qvc(i) = 0.
                           ELSE
                               rneb(i,k)=0.5*zpdf_e1(i)
                               zqn(i)=zq(i)*zpdf_e2(i)/zpdf_e1(i)
+                              !--AB grid-mean vapor in the cloud - we assume saturation adjustment
+                              qvc(i) = rneb(i,k) * zqs(i)
                           ENDIF
 
-                          rnebss(i,k)=0.0   !--added by OB (needed because of the convergence loop on time)
-                          fcontrN(i,k)=0.0  !--idem
-                          fcontrP(i,k)=0.0  !--idem
-                          qss(i,k)=0.0      !--idem
-
-                       ELSE ! in case of ice supersaturation by Audran
-
-                        !------------------------------------
-                        ! ICE SUPERSATURATION
-                        !------------------------------------
-
-                        CALL ice_sursat(pplay(i,k), paprs(i,k)-paprs(i,k+1), dtime, i, k, temp(i,k), zq(i), &
-                             gamma_ss(i,k), zqs(i), Tbef(i), rneb_seri(i,k), ratqs(i,k),                 &
-                             rneb(i,k), zqn(i), rnebss(i,k), qss(i,k),                                   & 
-                             Tcontr(i,k), qcontr(i,k), qcontr2(i,k), fcontrN(i,k), fcontrP(i,k) )
-
-                        ENDIF ! ((flag_ice_sursat.eq.0).or.(Tbef(i).gt.t_glace_min))
+                      ENDIF ! keepgoing
+                  ENDDO ! loop on klon
+
+                  ENDIF ! .NOT. ok_ice_supersat
+
+                  DO i=1,klon
+                      IF (keepgoing(i)) THEN
 
                         ! If vertical heterogeneity, change fraction by volume as well
@@ -958,8 +1079,20 @@
                     zqn(i) = zq(i)
                     rneb(i,k) = 1.0
-                    zcond(i) = MAX(0.0,zqn(i)-zqs(i))
+                    IF ( ok_unadjusted_clouds ) THEN
+                      !--AB We relax the saturation adjustment assumption
+                      !-- qvc (grid-mean vapor in cloud) is calculated by the condensation scheme
+                      zcond(i) = MAX(0., zqn(i) - qvc(i))
+                    ELSE
+                      zcond(i) = MAX(0.0,zqn(i)-zqs(i))
+                    ENDIF
                     rhcl(i,k)=1.0
                 ELSE
-                    zcond(i) = MAX(0.0,zqn(i)-zqs(i))*rneb(i,k)
+                    IF ( ok_unadjusted_clouds ) THEN
+                      !--AB We relax the saturation adjustment assumption
+                      !-- qvc (grid-mean vapor in cloud) is calculated by the condensation scheme
+                      zcond(i) = MAX(0., zqn(i) * rneb(i,k) - qvc(i))
+                    ELSE
+                      zcond(i) = MAX(0.0,zqn(i)-zqs(i))*rneb(i,k)
+                    ENDIF
                     ! following line is very strange and probably wrong:
                     rhcl(i,k)=(zqs(i)+zq(i))/2./zqs(i)
@@ -985,4 +1118,47 @@
           rneblsvol(1:klon,k)=ctot_vol(1:klon,k)
         ENDIF
+    
+    !--AB Write diagnostics and tracers for ice supersaturation
+    IF ( ok_ice_supersat ) THEN
+      CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,1,.false.,qsatl(:,k),zdqs)
+      CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,2,.false.,qsati(:,k),zdqs)
+
+      DO i = 1, klon
+
+        cf_seri(i,k) = rneb(i,k)
+
+        IF ( .NOT. ok_unadjusted_clouds ) THEN
+          qvc(i) = zqs(i) * rneb(i,k)
+        ENDIF
+        IF ( zq(i) .GT. min_qParent ) THEN
+          rvc_seri(i,k) = qvc(i) / zq(i)
+        ELSE
+          rvc_seri(i,k) = min_ratio
+        ENDIF
+        !--The MIN barrier is NEEDED because of:
+        !-- 1) very rare pathological cases of the lsc scheme (rvc = 1. + 1e-16 sometimes)
+        !-- 2) the thermal scheme does NOT guarantee that qvc <= qvap (or even qincld <= qtot)
+        !--The MAX barrier is a safeguard that should not be activated
+        rvc_seri(i,k) = MIN(MAX(rvc_seri(i,k), 0.), 1.)
+
+        !--Diagnostics
+        gamma_cond(i,k) = gammasat(i)
+        IF ( issrfra(i,k) .LT. eps ) THEN
+          issrfra(i,k) = 0.
+          qissr(i,k) = 0.
+        ENDIF
+        subfra(i,k) = 1. - cf_seri(i,k) - issrfra(i,k)
+        qsub(i,k) = zq(i) - qvc(i) - qissr(i,k)
+        IF ( subfra(i,k) .LT. eps ) THEN
+          subfra(i,k) = 0.
+          qsub(i,k) = 0.
+        ENDIF
+        qcld(i,k) = qvc(i) + zcond(i)
+        IF ( cf_seri(i,k) .LT. eps ) THEN
+          qcld(i,k) = 0.
+        ENDIF
+      ENDDO
+    ENDIF
+
 
     ! ----------------------------------------------------------------
@@ -1407,23 +1583,4 @@
     ENDDO
 
-    !--save some variables for ice supersaturation
-    !
-    DO i = 1, klon
-        ! for memory 
-        rneb_seri(i,k) = rneb(i,k)
-
-        ! for diagnostics
-        rnebclr(i,k) = 1.0 - rneb(i,k) - rnebss(i,k)
-
-        qvc(i,k) = zqs(i) * rneb(i,k)
-        qclr(i,k) = MAX(1.e-10,zq(i) - qvc(i,k) - qss(i,k))  !--added by OB because of pathologic cases with the lognormal
-        qcld(i,k) = qvc(i,k) + zcond(i)
-   ENDDO
-   !q_sat
-   CALL calc_qsat_ecmwf(klon,Tbef(:),qzero(:),pplay(:,k),RTT,1,.false.,qsatl(:,k),zdqs(:))
-   CALL calc_qsat_ecmwf(klon,Tbef(:),qzero(:),pplay(:,k),RTT,2,.false.,qsats(:,k),zdqs(:))
-
-
-
     ! Outputs:
     !-------------------------------
